unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, Buttons, StdCtrls, Mask, ComCtrls;
type TypRekordRabatowy = array [0..12] of byte;


type
  TForm1 = class(TForm)
    Label1: TLabel;
    sOdczyt: TSpeedButton;
    sZapisz: TSpeedButton;
    Label2: TLabel;
    MaskEdit2: TMaskEdit;
    seRekord: TSpinEdit;
    Label3: TLabel;
    sePort: TSpinEdit;
    pOpen: TSpeedButton;
    pClose: TSpeedButton;
    seSiec: TSpinEdit;
    rOdczyt: TSpeedButton;
    rZapis: TSpeedButton;
    sb1: TStatusBar;
    procedure pOpenClick(Sender: TObject);
    procedure pCloseClick(Sender: TObject);
    procedure sOdczytClick(Sender: TObject);
    procedure sZapiszClick(Sender: TObject);
    procedure rOdczytClick(Sender: TObject);
    procedure rZapisClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
function OtwartoPortSzeregowy(NrPortuDoZainicjowania : byte) : byte;StdCall;external 'rabster.dll'
function ZamknietoPortSzeregowy : byte;StdCall;external 'rabster.dll'
function OdczytanoNumerSieci (var NrSieci : byte) : byte;StdCall;external 'rabster.dll'
function ZapisanoNumerSieci (NrSieci : byte): byte;StdCall;external 'rabster.dll'
function OdczytanoRekordRabatowy(NrRekordu : byte;var Rekord : TypRekordRabatowy) : byte;StdCall;external 'rabster.dll'
function ZapisanoRekordRabatowy(NrRekordu : byte; Rekord : TypRekordRabatowy) : byte;StdCall;external 'rabster.dll'
function OdczytanieBajtuStatusu(var OdczytanyBajt : byte) : byte;StdCall;external 'rabster.dll'

{$R *.DFM}


procedure TForm1.pOpenClick(Sender: TObject);
var
 wynik : byte;
 blad : AnsiString;
begin

  wynik:=OtwartoPortSzeregowy(form1.sePort.Value);
  if wynik<>0 then
    begin
     sb1.SimpleText:='Blad '+IntToStr(Wynik);
     sb1.Refresh;
    end
  else
    begin
     sb1.SimpleText:='OK';
     sb1.Refresh;
    end ;
end;

procedure TForm1.pCloseClick(Sender: TObject);
var
 wynik : byte;
 Blad : AnsiString;
begin
  wynik:=ZamknietoPortSzeregowy;
  if wynik<>0 then
    begin
     sb1.SimplePanel:=True;
     sb1.SimpleText:='Blad '+IntToStr(Wynik);
     sb1.Refresh;
    end
  else
    begin
     sb1.SimplePanel:=True;
     sb1.SimpleText:='OK';
     sb1.Refresh;
    end
end;

procedure TForm1.sOdczytClick(Sender: TObject);
var
 wynik : byte;
 Blad : AnsiString;
 Licznik : byte;
 Nr : byte;
begin
  wynik:=OdczytanoNumerSieci(Nr);
  if wynik<>0 then
    begin
     sb1.SimplePanel:=True;
     sb1.SimpleText:='Blad '+IntToStr(Wynik);
     sb1.Refresh;
    end
  else
    begin
     form1.seSiec.Value:=Nr;
     sb1.SimplePanel:=True;
     sb1.SimpleText:='OK';
     sb1.Refresh;
    end
end;

procedure TForm1.sZapiszClick(Sender: TObject);
var
 wynik : byte;
 Blad : AnsiString;
 Licznik : byte;
 Nr : byte;
begin
  Nr:=form1.seSiec.Value;
  wynik:=ZapisanoNumerSieci(Nr);
  if wynik<>0 then
    begin
     sb1.SimplePanel:=True;
     sb1.SimpleText:='Blad '+IntToStr(Wynik);
     sb1.Refresh;
    end
  else
    begin
     form1.seSiec.Value:=Nr;
     sb1.SimplePanel:=True;
     sb1.SimpleText:='OK';
     sb1.Refresh;
    end
end;

procedure TForm1.rOdczytClick(Sender: TObject);
var
 wynik : byte;
 Blad : AnsiString;
 Licznik : byte;
 Nr : byte;
 Rek : TypRekordRabatowy;
 tmp : string;
begin
  Nr:=form1.seRekord.Value;
  wynik:=OdczytanoRekordRabatowy(Nr,Rek);
  if wynik<>0 then
    begin
     sb1.SimplePanel:=True;
     sb1.SimpleText:='Blad '+IntToStr(Wynik);
     sb1.Refresh;
    end
  else
    begin
     tmp:='';
     for Licznik:=0 to 12 do
        tmp:=tmp+chr(Rek[Licznik]);
      MaskEdit2.Text:=tmp;  
     form1.seSiec.Value:=Nr;
     sb1.SimplePanel:=True;
     sb1.SimpleText:='OK';
     sb1.Refresh;
    end
end;

procedure TForm1.rZapisClick(Sender: TObject);
var
 wynik : byte;
 Blad : AnsiString;
 Licznik : byte;
 Nr : byte;
 Rek : TypRekordRabatowy;

begin
  Nr:=form1.seRekord.Value;
  for Licznik:=0 to 12 do
     Rek[Licznik]:=ord(MaskEdit2.Text[Licznik+1]);
  wynik:=ZapisanoRekordRabatowy(Nr,Rek);
  if wynik<>0 then
    begin

     sb1.SimplePanel:=True;
     sb1.SimpleText:='Blad '+IntToStr(Wynik);
     sb1.Refresh;
    end
  else
    begin
     form1.seRekord.Value:=Nr;
     sb1.SimplePanel:=True;
     sb1.SimpleText:='OK';
     sb1.Refresh;
     rOdczyt.Click;
    end
end;

end.
